BZOJ3387 [USACO2004 Dec] Fence Obstacle Course栅栏行动

[Solution]

Simply modify some important positions by map or balanced tree. For each fence, remove all the nodes between a[i] and b[i]. Then add two new nodes on a[i] and b[i]. Each node will only be inserted and poped once. The total time complex is O(n lg n). It's very easy to code.


[Code]

#include <cstdio>
#include <cctype>
#include <memory.h>
#include <algorithm>

using namespace std;

typedef long long qw;

#ifdef WIN32
#define lld "%I64d"
#else
#define lld "%lld"
#endif

int nextInt() {
	int s = 0, d;
	bool flag = 0;
	do {
		d = getchar();
		if (d == '-')
			flag = 1;
	} while (!isdigit(d));
	do
		s = s * 10 + d - 48, d = getchar();
	while (isdigit(d));
	return flag ? -s : s;
}

const int maxn = 200009;
const qw qwinf = 0x3f3f3f3f3f3f3f3f;
const int intinf = 0x3f3f3f3f;

class sbt {
	private:
		int root, ls[maxn], rs[maxn], sz[maxn], key[maxn];
		int nst[maxn], tnst;
		qw val[maxn], ansl, ansr;
		inline void update(const int& p) {
			sz[p] = sz[ls[p]] + sz[rs[p]] + 1;
		}
		inline void lRot(int& p) {
			int q = rs[p];
			if (!q)
				return;
			rs[p] = ls[q];
			ls[q] = p;
			update(p);
			update(q);
			p = q;
		}
		inline void rRot(int& p) {
			int q = ls[p];
			if (!q)
				return;
			ls[p] = rs[q];
			rs[q] = p;
			update(p);
			update(q);
			p = q;
		}
		void maintain(int& p, bool flag) {
			if (flag) {
				if (sz[ls[p]] + 1 > sz[rs[p]])
					rRot(p);
			}
			else
				if (sz[ls[p]] < sz[rs[p]] + 1)
					lRot(p);
		}
		void ins(int& p, int k0, qw v0) {
			if (!p) {
				p = nst[-- tnst];
				ls[p] = 0;
				rs[p] = 0;
				sz[p] = 1;
				key[p] = k0;
				val[p] = v0;
			}
			else if (key[p] == k0)
				val[p] = min(val[p], v0);
			else {
				if (k0 < key[p])
					ins(ls[p], k0, v0);
				else
					ins(rs[p], k0, v0);
				update(p);
				maintain(p, k0 < key[p]);
			}
		}
		void del(int& p, int k0) {
			if (key[p] == k0) {
				if (!ls[p] || !rs[p])
					nst[tnst ++] = p;
				if (!ls[p])
					p = rs[p];
				else if (!rs[p])
					p = ls[p];
				else {
					int q = ls[p];
					while (rs[q])
						q = rs[q];
					key[p] = key[q];
					val[p] = val[q];
					del(ls[p], key[p]);
					if (p)
						update(p);
				}
			}
			else {
				if (k0 < key[p])
					del(ls[p], k0);
				else
					del(rs[p], k0);
				if (p)
					update(p);
			}
		}
		void ers(int& p, int l, int r) {
			while (p && key[p] >= l && key[p] <= r) {
				ansl = min(ansl, val[p] + key[p] - l);
				ansr = min(ansr, val[p] + r - key[p]);
				del(p, key[p]);
			}
			if (p && l < key[p])
				ers(ls[p], l, r);
			if (p && r > key[p])
				ers(rs[p], l, r);
			if (p)
				update(p);
		}
		qw getAns(int p) {
			if (!p)
				return qwinf;
			else
				return min(val[p] + abs(key[p]), min(getAns(ls[p]), getAns(rs[p])));
		}
	public:
		void init() {
			root = 0;
			sz[0] = 0;
			tnst = 0;
			for (int i = 1; i < maxn; i ++)
				nst[tnst ++] = i;
		}
		void insert(int k0, qw v0) {
			ins(root, k0, v0);
		}
		void erase(int l0, int r0, qw& sl, qw& sr) {
			ansl = qwinf;
			ansr = qwinf;
			ers(root, l0, r0);
			sl = ansl;
			sr = ansr;
		}
		int minKey() {
			int p = root;
			while (ls[p])
				p = ls[p];
			return p ? key[p] : intinf;
		}
		int maxKey() {
			int p = root;
			while (rs[p])
				p = rs[p];
			return p ? key[p] : -intinf;
		}
		qw getAns() {
			return getAns(root);
		}
		int size() {
			return sz[root];
		}
		void disp(int p = -1) {
			if (p == -1)
				p = root;
			if (!p)
				return;
			disp(ls[p]);
			printf("%3d:%6lld\n", key[p], val[p]);
			disp(rs[p]);
		}
};

sbt t;
int n, p0, a[maxn], b[maxn];

int main() {
#ifndef ONLINE_JUDGE
	freopen("in.txt", "r", stdin);
#endif

	t. init();
	n = nextInt();
	p0 = nextInt();
	for (int i = 1; i <= n; i ++) {
		a[i] = nextInt();
		b[i] = nextInt();
	}
	t. insert(p0, 0);
	for (int i = n; i; i --) {
		if (a[i] >= t. maxKey() || b[i] <= t. minKey())
			continue;
		qw ansl, ansr;
		t. erase(a[i], b[i], ansl, ansr);
		t. insert(a[i], ansl);
		t. insert(b[i], ansr);
	}
	printf(lld "\n", t. getAns());
}


题目描述 牛牛和她的朋友们正在玩一个有趣的游戏,他们需要构建一个有 $n$ 个节点的无向图,每个节点都有一个唯一的编号并且编号从 $1$ 到 $n$。他们需要从节点 $1$ 到节点 $n$ 找到一条最短路径,其中路径长度是经过的边权的和。为了让游戏更有趣,他们决定在图上添加一些额外的边,这些边的权值都是 $x$。他们想知道,如果他们添加的边数尽可能少,最短路径的长度最多会增加多少。 输入格式 第一行包含两个正整数 $n$ 和 $m$,表示节点数和边数。 接下来 $m$ 行,每行包含三个整数 $u_i,v_i,w_i$,表示一条无向边 $(u_i,v_i)$,权值为 $w_i$。 输出格式 输出一个整数,表示最短路径的长度最多会增加多少。 数据范围 $2 \leq n \leq 200$ $1 \leq m \leq n(n-1)/2$ $1 \leq w_i \leq 10^6$ 输入样例 #1: 4 4 1 2 2 2 3 3 3 4 4 4 1 5 输出样例 #1: 5 输入样例 #2: 4 3 1 2 1 2 3 2 3 4 3 输出样例 #2: 2 算法 (BFS+最短路) $O(n^3)$ 我们把问题转化一下,假设原图中没有添加边,所求的就是点 $1$ 到点 $n$ 的最短路,并且我们已经求出了这个最短路的长度 $dis$。 接下来我们从小到大枚举边权 $x$,每次将 $x$ 加入图中,然后再次求解点 $1$ 到点 $n$ 的最短路 $dis'$,那么增加的最短路长度就是 $dis'-dis$。 我们发现,每次加入一个边都需要重新求解最短路。如果我们使用 Dijkstra 算法的话,每次加入一条边需要 $O(m\log m)$ 的时间复杂度,总的时间复杂度就是 $O(m^2\log m)$,无法通过本题。因此我们需要使用更优秀的算法。 观察到 $n$ 的范围比较小,我们可以考虑使用 BFS 求解最短路。如果边权均为 $1$,那么 BFS 可以在 $O(m)$ 的时间复杂度内求解最短路。那么如果我们只是加入了一条边的话,我们可以将边权为 $x$ 的边看做 $x$ 条边的组合,每次加入该边时,我们就在原始图上添加 $x$ 条边,边权均为 $1$。这样,我们就可以使用一次 BFS 求解最短路了。 但是,我们不得不考虑加入多条边的情况。如果我们还是将边权为 $x$ 的边看做 $x$ 条边的组合,那么我们就需要加入 $x$ 条边,而不是一条边。这样,我们就不能使用 BFS 了。 但是,我们可以使用 Floyd 算法。事实上,我们每次加入边时,只有边权等于 $x$ 的边会发生变化。因此,如果我们枚举边权 $x$ 时,每次只需要将边权等于 $x$ 的边加入图中,然后使用 Floyd 算法重新计算最短路即可。由于 Floyd 算法的时间复杂度为 $O(n^3)$,因此总的时间复杂度为 $O(n^4)$。 时间复杂度 $O(n^4)$ 空间复杂度 $O(n^2)$ C++ 代码 注意点:Floyd算法计算任意两点之间的最短路径,只需要在之前的路径基础上加入新的边构成的新路径进行更新即可。
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值